import { ESSceneObject, GeoAxis, PositionEditing, PrsEditing, RotationEditing } from 'xbsj-xe2/dist-node/xe2-base-objects';
import { Listener, PartialWithUndefinedReactivePropsToNativeProps, ReactivePropsToNativePropsAndChanged } from 'xbsj-xe2/dist-node/xe2-base-utils';
import { SceneObjectKey } from 'xbsj-xe2/dist-node/xe2-utils';
import { CzmPolylinesPrimitive } from './CzmPolylinesPrimitive';
export declare class CzmPlane extends ESSceneObject {
    static readonly type: string;
    get typeName(): string;
    get defaultProps(): {
        show: boolean;
        showArrow: boolean;
        editing: boolean;
        positionEditing: boolean;
        rotationEditing: boolean;
        position: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        rotation: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        color: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        width: number;
        minSize: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        maxSize: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
    get json(): JsonType;
    set json(value: JsonType);
    private _flyToEvent;
    get flyToEvent(): Listener<[number | undefined]>;
    flyTo(duration?: number): void;
    static defaults: {
        position: [number, number, number];
        viewerTagsEnums: [string, string][];
    };
    private _sPositionEditing;
    get sPositionEditing(): PositionEditing;
    private _sRotationEditing;
    get sRotationEditing(): RotationEditing;
    private _sPrsEditing;
    get sPrsEditing(): PrsEditing;
    private _polylines;
    get polylines(): CzmPolylinesPrimitive;
    private _polylinesInit;
    private _axis;
    get axis(): GeoAxis;
    private _axisInit;
    constructor(id?: SceneObjectKey);
    getProperties(language?: string): import("xbsj-xe2/dist-node/xe2-base-objects").Property[];
}
export declare namespace CzmPlane {
    const createDefaultProps: () => {
        show: boolean;
        showArrow: boolean;
        editing: boolean;
        positionEditing: boolean;
        rotationEditing: boolean;
        position: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number] | undefined>;
        rotation: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number]>;
        color: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number, number, number]>;
        width: number;
        minSize: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        maxSize: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<[number, number]>;
        execOnceFuncStr: string | undefined;
        updateFuncStr: string | undefined;
        toDestroyFuncStr: string | undefined;
        name: string;
        ref: string | undefined;
        devTags: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<string[] | undefined>;
        extras: import("xbsj-xe2/dist-node/xe2-base-utils").ReactiveVariable<import("xbsj-xe2/dist-node/xe2-base-utils").JsonValue>;
    };
}
export interface CzmPlane extends ReactivePropsToNativePropsAndChanged<ReturnType<typeof CzmPlane.createDefaultProps>> {
}
declare type JsonType = PartialWithUndefinedReactivePropsToNativeProps<ReturnType<typeof CzmPlane.createDefaultProps> & {
    type: string;
}>;
export {};
